package com.jkcredit.illegal.info.controller;

import com.jkcredit.illegal.info.model.*;
import com.jkcredit.illegal.info.service.IllegalInfoService;
import com.jkcredit.illegal.info.service.IllegalInfoTestService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/9/22 11:35
 * @version: V1.0
 **/
@RestController
@RequestMapping("/yi")
@Slf4j
public class IllegalInfoController {
    @Autowired
    IllegalInfoService illegalInfoService;
    @Autowired
    IllegalInfoTestService illegalInfoTestService;

    @PostMapping("/checkIllegalInfo.do")
    public CommonResponseObject checkIllegalInfo(@RequestBody IllegalInfoRequestParam requestParams) {
        log.info("checkIllegalInfo-接收参数：{}", requestParams);
        IllegalInfoResult illegalInfoResult = illegalInfoService.checkIllegalInfoV2(requestParams);
        if (illegalInfoResult != null) {
            log.info("checkIllegalInfo-返回：{}", illegalInfoResult);
            return CommonResponseObject.success(illegalInfoResult);
        } else {
            return CommonResponseObject.failure();
        }
    }

    @PostMapping("/checkVehicleIllegalInfo.do")
    public CommonResponseObject checkVehicleIllegalInfo(@RequestBody CommonParamObject params) {

        log.info("checkVehicleIllegalInfo-接收参数：{}", params);
        VehicleIllegalInfoResult illegalInfoResult = illegalInfoService.checkVehicleIllegalInfo(params.getParam());
        if (illegalInfoResult != null) {
            log.info("checkVehicleIllegalInfo-返回：{}", illegalInfoResult);
            return CommonResponseObject.success(illegalInfoResult);
        } else {
            return CommonResponseObject.failure();
        }
    }

    @PostMapping("/checkPersonIllegalInfo.do")
    public CommonResponseObject checkPersonIllegalInfo(@RequestBody CommonParamObject params) {
        log.info("checkPersonIllegalInfo-接收参数：{}", params);
        IllegalInfoResult illegalInfoResult = illegalInfoService.checkPersonIllegalInfo(params.getParam());
        if (illegalInfoResult != null) {
            log.info("checkPersonIllegalInfo-返回：{}", illegalInfoResult);
            return CommonResponseObject.success(illegalInfoResult);
        } else {
            return CommonResponseObject.failure();
        }
    }

    @PostMapping("/checkIllegalInfoTest.do")
    public CommonResponseObject checkIllegalInfoTest(@RequestBody IllegalInfoRequestParam requestParams) {
        IllegalInfoResult illegalInfoResult = illegalInfoTestService.checkIllegalInfoTest(requestParams);
        if (illegalInfoResult != null) {
            return CommonResponseObject.success(illegalInfoResult);
        } else {
            return CommonResponseObject.failure();
        }
    }

    @PostMapping("/checkVehicleIllegalInfoTest.do")
    public CommonResponseObject checkVehicleIllegalInfoTest(@RequestBody VehicleIllegalInfoRequestParam requestParams) {
        VehicleIllegalInfoResult illegalInfoResult = illegalInfoTestService.checkVehicleIllegalInfo(requestParams);
        if (illegalInfoResult != null) {
            return CommonResponseObject.success(illegalInfoResult);
        } else {
            return CommonResponseObject.failure();
        }
    }
}
