package com.jkcredit.illegal.info.util;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Slf4j
public class HttpClientUtil {
    public static String sendPost(String url, String jsonStr, int outTime, String token) {
        CloseableHttpClient httpClient = HttpClients.createDefault();
        RequestConfig requestConfig = RequestConfig.custom().setConnectionRequestTimeout(1000)
                .setSocketTimeout(outTime).setConnectTimeout(3000).build();
        HttpPost httpPost = new HttpPost(url);
        String result = null;
        try {
            httpPost = new HttpPost(url);
            httpPost.setConfig(requestConfig);
            httpPost.addHeader("Content-Type", "application/json");
            httpPost.addHeader("Accept", "application/json");
            if (StringUtils.isNotBlank(token)) {
                httpPost.addHeader("token", token);
            }
            StringEntity entity = new StringEntity(jsonStr, "utf-8");
            httpPost.setEntity(entity);
            HttpResponse response = httpClient.execute(httpPost);
            if (response != null) {
                HttpEntity resEntity = response.getEntity();
                if (resEntity != null) {
                    result = EntityUtils.toString(resEntity, "utf-8");
                }
            }
        } catch (IOException ioe) {
            log.info("sendPost, 参数：{}-SocketTimeoutException：", jsonStr, ioe);
        }
        return result;
    }
}
