package com.jkcredit.illegal.info.util;


import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.net.ssl.*;
import java.io.FileInputStream;
import java.io.InputStream;
import java.security.KeyStore;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

@Component
public class RxUtil {
    private static String CERTIFICATE_URL;
    private static String CERTIFICATE_PASSWORD;

    @Value("${illegalInfo.certificateUrl}")
    public void setCertificateUrl(String certificateUrl) {
        CERTIFICATE_URL = certificateUrl;
    }

    @Value("${illegalInfo.certificatePassword}")
    public void setCertificatePassword(String certificatePassword) {
        CERTIFICATE_PASSWORD = certificatePassword;
    }

    public static SSLSocketFactory createSSLSocketFactory() {
        SSLSocketFactory sSLSocketFactory = null;
        try {
            KeyStore clientStore = KeyStore.getInstance("PKCS12");
            InputStream instream = new FileInputStream(CERTIFICATE_URL);
            clientStore.load(instream, CERTIFICATE_PASSWORD.toCharArray());
            SSLContext sc = SSLContext.getInstance("TLS");
            KeyManagerFactory kmfactory = KeyManagerFactory.getInstance(KeyManagerFactory.getDefaultAlgorithm());
            kmfactory.init(clientStore, CERTIFICATE_PASSWORD.toCharArray());
            KeyManager[] keymanagers = kmfactory.getKeyManagers();
            sc.init(keymanagers, new TrustManager[]{new TrustAllManager()},
                    new SecureRandom());
            sSLSocketFactory = sc.getSocketFactory();
        } catch (Exception ignored) {
        }
        return sSLSocketFactory;
    }

    public static class TrustAllManager implements X509TrustManager {

        @Override
        public void checkClientTrusted(X509Certificate[] chain, String authType)
                throws CertificateException {
        }

        @Override
        public void checkServerTrusted(X509Certificate[] chain, String authType)
                throws CertificateException {
        }

        @Override
        public X509Certificate[] getAcceptedIssuers() {
            return new X509Certificate[0];
        }
    }

    public static class TrustAllHostnameVerifier implements HostnameVerifier {
        @Override
        public boolean verify(String hostname, SSLSession session) {
            return true;
        }
    }
}
